--[[
Laserix, Copyright (c) 2005 Jason Storhed <wip3out1907@yahoo.com>

-----------Laserix 3 by Team Sunny--------------- 

    Coder: SUNNY <kingsunny@hotmail.de>
	Designer/GFXer: king & barot97
	Beta-Tester: Rancher & Sherker
-------------------------------------------------
VISIT http://www.kingmedia.org
-------------------------------------------------
And now, have fun =),
Team Sunny
]]



--map = 16x13
-- tile = 21x21
--tile size = 336x273
--array size = 208
--mirrortype2 default=67.5

maxLevel=52
acc=0
downPress=false
upPress=false
rightPress=false
leftPress=false
hintTime=0
message=0
xposActiv=0
yposActiv=0
flashX=0
flashY=0
drawStartX=72 --Where the gameboard is drawn in X (boards left side). 72=middle
keyDelay=0
trianglePress=false
laserOn=false
mirrorSelected=false
shootLoops=0
addLaserLenght=0
laserAngle=0
diamonds=0
moveBlockChanges=0
staticX=0
levelCleared=false
menu=1
menuX=180
gotoMenuX=menuX
tmpLevel=1
level=1
loadedLevel = 1
msg_to_draw = nil
menu1 = 0
mp3_vol = 30000
mp3_fac = 0
press_select = nil

schwarz = pge.gfx.createcolor(0,0,0)
diamondsLoaded=0
objectsLoaded=0
LetterPixelsWide = 17
LetterPixelsTall = 18
ttime = 0
InputString = [[ .:/ABCDEFGHIJKLMNOPQRSTUVWXYZ]]

map={}
loadedMap = {}
cannonAngle = 0
mirrorsTypeA = 0
mirrorsTypeB = 0

function set_mp3_volume()
	pge.mp3.volume( mp3_vol/mp3_fac )
end

-- INIT BEGIN

pge.mp3.play("song1.mp3") pge.mp3.loop(true)
mp3_fac = 2
set_mp3_volume()

bild = pge.texture.load("Logo1.png")
	   pge.gfx.startdrawing()
	   bild:activate()
	   bild:draweasy(0,0)
	   pge.gfx.enddrawing()
	   pge.gfx.swapbuffers()
	   pge.delay(1000)

bild2 = pge.texture.load("credits.png")
	    pge.gfx.startdrawing()
	    bild:activate()
	    bild:draweasy(0,0)
	    pge.gfx.enddrawing()
	    pge.gfx.swapbuffers()
	    pge.delay(2000)

datafile = pge.zip.open("laserix3.dat")
if not datafile then error("Failed to open laserix.dat") end

function zip_data(fn)
	zf = datafile:read(fn)
	if zf == nil then error("failed to unzip "..fn) end
	return zf:data()
end

font1 = pge.texture.loadmemory(zip_data("fontfina11l.png"))
background = pge.texture.loadmemory(zip_data("background.png"))
objectImage = pge.texture.loadmemory(zip_data("objects.png"))
aim = pge.texture.loadmemory(zip_data("aim.png"))
cannon = pge.texture.loadmemory(zip_data("cannon.png"))
mirrorsA = pge.texture.loadmemory(zip_data("mirrorsA.png"))
mirrorsB = pge.texture.loadmemory(zip_data("mirrorsB.png"))
gui = pge.texture.loadmemory(zip_data("gui.png"))
laser = pge.texture.loadmemory(zip_data("laser1.png"))          --depends on level
fx = pge.texture.loadmemory(zip_data("fx.png"))
fx_lighting = pge.texture.loadmemory(zip_data("fx_lighting.png"))
msg_1 = pge.texture.loadmemory(zip_data("msg_1.png"))
msg_2 = pge.texture.loadmemory(zip_data("msg_2.png"))
msg_5 = pge.texture.loadmemory(zip_data("msg_3.png"))
msg_4 = pge.texture.loadmemory(zip_data("msg_4.png"))
endscreen = pge.texture.loadmemory(zip_data("end.png"))
menu_background = pge.texture.loadmemory(zip_data("menu_background.png"))
lock = pge.texture.loadmemory(zip_data("lock.png"))
level_background = pge.texture.loadmemory(zip_data("level_background.png"))
font = pge.texture.loadmemory(zip_data("font.png"))

sound_move_mirror = pge.wav.loadmemory(zip_data("move_mirror.wav"))
sound_place_mirror = pge.wav.loadmemory(zip_data("place_mirror.wav"))
sound_hit_mirror = pge.wav.loadmemory(zip_data("hit_mirror.wav"))
sound_elec = pge.wav.loadmemory(zip_data("elec.wav"))
sound_diamond = pge.wav.loadmemory(zip_data("hit_diamond.wav"))
sound_menu_click = pge.wav.loadmemory(zip_data("menu_click.wav"))

menu_lvl={}
for i=1, maxLevel, 1 do
	menu_lvl[i] = pge.texture.loadmemory(zip_data("menu_lvl_"..i..".png"))
end

pge.zip.close(datafile)

staticImage = pge.texture.create(480, 272,PGE_PIXEL_FORMAT_8888, PGE_VRAM)
if not staticImage then error("texture.create failed") end

function screen_blit(xd,yd,tex,xs,ys,ws,hs,alp)
	pge.texture.activate(tex)
	pge.texture.draw(tex,xd,yd,ws,hs,xs,ys,ws,hs) 
end

function tex_blit(target,xd,yd,tex,xs,ys,ws,hs,alp) -- target must be in vram
	if not pge.texture.settarget(target) then error("texture.settarget failed") end
	pge.texture.activate(tex)
	pge.texture.draw(tex,xd,yd,ws,hs,xs,ys,ws,hs) 
	pge.gfx.rendertoscreen()
end

function ScreenShot()
    name='screenshot_'
    counter=0
    extension='.png'

    while pge.file.exists(name..counter..extension) do
        counter=counter+1
    end

    pge.gfx.screenshot(name..counter..extension)
end

function char2font(char_input)
	IndexNumber = 0
	for i = 1, string.len(InputString) do
		if string.sub(InputString, i,i) == char_input then
			return IndexNumber
		end -- end if
		IndexNumber = IndexNumber + LetterPixelsWide
	end -- end if
	return 0
end -- char2font

function loadMap(i)

	diamondsLoaded=0
	objectsLoaded=0
	LetterPixelsWide = 23
	LetterPixelsTall = 18
	ttime = 0
	InputString = [[ .:/ABCDEFGHIJKLMNOPQRSTUVWXYZ]]


	---- level begin
	-- Level by SUNNY
	if i == 1 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=0
		mirrorsTypeA=2
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 2 then
		loadedMap={0,0,0,0,10,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,2,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,1,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=180
		mirrorsTypeA=13
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 3 then
		loadedMap={0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,1,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0}
		cannonAngle=90
		mirrorsTypeA=6
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 4 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=225
		mirrorsTypeA=2
		mirrorsTypeB=1
	end

	-- Level by SUNNY
	if i == 5 then
		loadedMap={0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,2,0,11,0,0,0,0,0,1,0,0,0,0,0,0,0,0,2,10,2,2,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,2,0,1,0,0,0,0,4,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,2}
		cannonAngle=270
		mirrorsTypeA=10
		mirrorsTypeB=0
	end

	-- Level by SUNNY 
	if i == 6 then                                                                                                                                                                                                                                                                                                                                                          
		loadedMap={0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,11,10,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,2,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,2,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,1,2,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,2,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0}
		cannonAngle=0
		mirrorsTypeA=2
		mirrorsTypeB=1
	end

	-- Level by SUNNY
	if i == 7 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,2,0,0,0,0,10,0,0,0,0,0,0,0,0,2,2,0,2,2,0,0,0,0,0,0,0,1,0,0,2,0,0,2,1,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,2,0,2,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0,0,1,0,0,2,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,2,0,0}
		cannonAngle=225
		mirrorsTypeA=5
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 8 then
		loadedMap={0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,2,2,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,2,0,0,0,0,2,0,0,0,2,0,0,2,0,0,0,0,2,0,0,0,2,0,0,0,0,2,0,2,0,10,11,0,2,0,0,2,0,0,0,0,2,0,0,2,0,0,1,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,1,2,0,0,1,0,2,0,0,0,2,0,0,0,0,2,2,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=180
		mirrorsTypeA=2
		mirrorsTypeB=3
	end


	-- Level by SUNNY
	if i == 9 then
		loadedMap={0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,1,2,0,0,0,0,0,2,0,0,0,2,0,0,0,0,2,0,0,0,0,0,2,0,0,0,2,0,2,0,11,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,10,0,0,2,0,2,0,2,0,0,0,2,2,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,2,2,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,2,0,0,0,2,1,2,0,0,0,2,0,0,2,0,2,1,2,0,0,0,2,0,0,0,0,0,2,2,1,2,0,2,0,0,2,0,0,0,0,2,0,2,0,0,2,0,0,0,0,2,0,2,0,0,2,0,2,0,2,0,0,0,0,0,0,0,2,0,0,0,0,2,0,2,0}
		cannonAngle=315
		mirrorsTypeA=6
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 10 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,2,2,2,7,0,0,0,0,0,0,0,0,6,1,8,0,10,11,0,0,6,0,0,2,0,0,0,0,0,2,0,2,2,2,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,1,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,7,7,7,7,7,9,7,7,7,0,9,7,0,0,0,0,0,0,0,0,1,0,0,0,0,8,0,0,6,0,0,0,2,0,2,0,2,0,2,0,2,0,9,9,0,0,0,0,0,2,0,2,0,2,0,2,0,0,0,0,0,2,0,0,2,0,2,0,2,0,2,0,2,0,0,0,2,0,2,0,0,2,0,2,0,2,0,2,0,0,0,0,0,2,0,0}
		cannonAngle=180
		mirrorsTypeA=12
		mirrorsTypeB=0
	end

    -- Level by SUNNY
	if i == 11 then
		loadedMap={0,0,0,0,0,0,0,5,0,0,0,0,0,0,2,0,0,0,0,0,0,0,5,1,5,0,0,0,0,2,0,0,0,0,0,2,0,0,0,5,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,5,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,2,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,2,0,11,10,0,5,0,0,0,0,0,0,0,0,0,2,0,0,0,0,9,0,5,0,0,0,0,0,0,0,2,0,0,0,0,0,1,0,0,5,0,0,0,0,0,2,0,0,0,0,0,0,5,0,0,0,5,0,0}
		cannonAngle=0
		mirrorsTypeA=4
		mirrorsTypeB=1
	end

	-- Level by SUNNY
	if i == 12 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,11,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,10,0,0,0,5,0,0,0,0,2,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,5,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,2,0,0,2,2,0,0,0,0,0,0,0,0,5,0,2,0,0,2,0,0,2,0,0,0,0,0,0,5,4,5,0,2,0,0,0,0,2,0,0,0,0,0,0,0,1,0,2,0,0,0,0,2,0,0,0,0,0,0,0,0,5,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0}
		cannonAngle=270
		mirrorsTypeA=3
		mirrorsTypeB=2
	end


	-- Level by SUNNY
	if i == 13 then
		loadedMap={0,0,3,0,3,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,3,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,2,2,2,0,2,2,2,0,0,2,0,0,2,1,2,0,2,2,2,0,2,2,0,0,0,2,0,0,2,2,2,0,10,11,2,1,2,0,0,2,2,2,2,0,2,0,2,0,2,2,2,0,2,2,2,0,0,0,0,0,2,2,2,0,0,2,0,2,0,2,0,2,2,0,0,0,2,0,2,0,0,2,0,2,0,2,0,0,2,0,0,0,2,2,2,0,0,2,0,1,2,0,0,2,2,0,0,0,2,2,0,0,0,2,0,2,0,2,4,0,2,0,0,0,2,0,2,0,0,2,0,2,0,2,0,2,2}
		cannonAngle=180
		mirrorsTypeA=3
		mirrorsTypeB=5
	end

	-- Level by SUNNY
	if i == 14 then
		loadedMap={2,0,0,0,0,0,0,2,2,0,0,0,0,0,0,2,0,2,0,0,0,0,5,2,2,0,0,1,0,0,2,0,0,0,2,0,0,9,4,5,0,2,2,0,0,2,0,0,0,0,1,2,2,0,0,5,0,0,2,2,2,0,0,0,0,0,0,2,2,0,1,5,0,0,0,2,2,0,0,0,0,0,0,2,2,9,2,2,2,7,2,2,2,0,0,0,0,0,0,2,2,3,0,0,10,11,0,2,2,0,0,0,0,0,0,0,2,2,0,0,0,0,2,2,0,0,0,0,0,0,0,0,2,2,2,0,0,2,2,2,0,0,0,0,0,0,0,2,0,0,2,2,2,2,0,0,2,0,0,0,0,0,2,0,0,0,0,2,2,0,1,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2}
		cannonAngle=180
		mirrorsTypeA=6
		mirrorsTypeB=4
	end

	-- Level by SUNNY
	if i == 15 then
		loadedMap={0,2,0,0,2,0,0,0,2,0,5,1,2,0,0,0,2,0,0,2,5,0,0,2,0,0,0,2,0,5,0,2,0,5,2,0,0,5,2,0,5,0,2,0,0,0,2,0,0,2,0,0,0,2,0,0,0,2,0,0,1,2,0,0,2,0,0,0,2,0,0,0,2,0,5,0,2,0,5,0,0,0,0,2,0,5,0,2,0,0,0,2,0,0,0,2,0,0,2,0,0,1,2,0,0,0,2,0,0,0,2,0,0,2,0,0,0,2,0,5,0,2,0,5,0,2,0,0,2,0,5,0,2,0,0,0,2,0,0,0,2,0,0,2,0,0,0,2,0,0,1,2,0,0,10,2,0,0,2,0,0,0,2,1,5,0,2,0,5,11,2,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,2,0,0,2,2,0,0,0,2,0,0,0,2,0,0,2,0,0,2,0}
		cannonAngle=45
		mirrorsTypeA=4
		mirrorsTypeB=0
	end


	-- Level by SUNNY
	if i == 16 then
		loadedMap={0,2,0,0,0,0,11,0,0,0,0,0,1,0,0,0,1,2,2,2,2,2,10,2,2,2,2,2,2,2,9,2,0,2,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,2,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,2,0,0,0,0,0,0,0,0,0,2,3,2,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,2,0,0,0,2,0,0,2,0,0,0,2,0,0,2,1,2,0,0,0,2,0,0,0,2,0,2,0,0,0,2,0,2,0,0,0,2,0,0,0,0,5,0,0,0,0,2,0,2,0,0,0,2,0,0,0,2,0,2,0,0,0,0,5,0,2,2,4,2,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=270
		mirrorsTypeA=5
		mirrorsTypeB=2
    end


	-- Level by SUNNY
       if i == 16 then
		loadedMap={0,2,0,0,0,0,11,0,0,0,0,0,1,0,0,0,1,2,2,2,2,2,10,2,2,2,2,2,2,2,9,2,0,2,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,2,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,2,0,0,0,0,0,0,0,0,0,2,3,2,0,0,0,2,0,2,0,0,0,0,0,2,0,2,0,2,0,0,0,2,0,0,2,0,0,0,2,0,0,2,1,2,0,0,0,2,0,0,0,2,0,2,0,0,0,2,0,2,0,0,0,2,0,0,0,0,5,0,0,0,0,2,0,2,0,0,0,2,0,0,0,2,0,2,0,0,0,0,5,0,2,2,4,2,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=270
		mirrorsTypeA=5
		mirrorsTypeB=2
	end

	-- Level by SUNNY
	if i == 17 then
		loadedMap={2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,2,4,2,1,2,1,2,0,2,0,2,0,2,0,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,2,2,2,2,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,2,2,2,0,0,0,0,0,0,2,0,0,3,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,2,2,2,2,0,0,10,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,11,2,0,0,0,0,0,0}
		cannonAngle=90
		mirrorsTypeA=4
		mirrorsTypeB=3
	end

	-- Level by SUNNY.
	if i == 18 then
		loadedMap={0,0,0,0,0,0,0,0,6,1,8,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0,0,0,2,0,0,0,0,0,2,5,2,0,0,2,2,0,0,0,0,2,0,0,0,2,0,0,2,0,1,0,2,2,0,0,0,0,2,0,2,0,5,0,2,0,0,0,0,2,0,0,0,0,0,2,0,5,1,5,2,0,1,0,2,2,0,0,0,0,2,0,2,0,5,0,2,0,0,2,2,0,0,0,0,2,0,0,0,2,0,0,2,0,0,2,0,0,0,0,2,0,0,0,0,0,2,5,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=0
		mirrorsTypeA=4
		mirrorsTypeB=3
	end

	-- Level by SUNNY
	if i == 19  then
		loadedMap={0,0,0,0,0,2,5,5,2,0,0,0,0,0,0,0,0,0,2,0,0,2,5,5,2,0,1,2,0,0,0,0,0,0,2,0,1,2,2,2,2,0,0,2,0,0,0,0,3,0,2,0,0,0,0,1,0,2,2,2,2,7,2,0,2,2,2,2,2,2,2,2,2,2,2,2,2,4,2,2,0,0,0,8,0,0,0,11,0,0,0,0,2,9,2,0,9,2,2,2,2,2,7,10,0,2,0,0,2,0,0,0,0,2,5,5,5,2,0,0,0,2,0,0,2,0,1,0,3,2,5,5,5,2,0,0,0,2,0,0,2,5,5,0,0,2,5,5,5,2,0,0,0,2,0,0,2,0,1,0,7,2,2,2,2,2,0,0,0,0,0,0,2,0,5,5,0,0,0,8,0,0,0,0,0,2,0,0,2,0,0,0,0,2,0,2,0,2,0,0,0,0,0,0,2,0,0,1}
		cannonAngle=270
		mirrorsTypeA=6
		mirrorsTypeB=5
	end

	-- Level by SUNNY
	if i == 20 then
		loadedMap={0,0,0,0,0,0,2,4,0,0,0,2,0,2,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,1,0,0,2,1,0,2,0,1,0,0,0,2,0,0,0,2,0,0,2,0,2,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,8,0,0,0,10,11,1,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,2,0,2,0,0,0,0,0,2,0,0,0,2,1,0,0,2,1,0,2,0,0,0,0,0,2,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,2,3,0,0,0,2,0,2,0,0}
		cannonAngle=180
		mirrorsTypeA=0
		mirrorsTypeB=4
	end

	-- Level by SUNNY
	if i == 21  then
		loadedMap={5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,8,0,0,0,0,0,0,5,5,5,5,5,0,0,0,0,5,0,0,0,0,0,0,0,5,5,5,0,0,0,0,0,5,5,0,0,0,0,0,0,0,5,5,0,0,0,0,0,0,5,5,0,0,0,0,0,0,5,5,0,0,0,0,0,0,0,5,5,0,0,5,0,0,5,5,0,0,0,0,0,5,5,5,5,0,0,1,0,0,0,5,0,0,0,0,0,5,5,11,10,0,0,1,0,1,5,5,0,1,0,0,0,0,5,5,0,0,0,5,0,0,5,5,0,0,0,0,0,0,0,5,5,0,0,0,0,0,5,5,5,0,0,0,0,0,0,0,5,0,0,0,0,5,5,5,5,5,0,0,0,0,0,0,6,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}
		cannonAngle=0
		mirrorsTypeA=3
		mirrorsTypeB=5
	end

	-- Level by SUNNY
	if i == 22 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,2,2,2,2,2,2,2,2,2,0,0,2,0,1,2,0,2,4,0,0,0,0,1,0,2,0,0,2,0,2,0,2,2,2,2,2,2,2,2,9,2,0,10,2,0,1,0,0,5,0,0,0,0,0,0,0,0,0,11,2,0,2,0,0,0,0,0,1,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,2,0,1,0,7,2,2,2,2,2,2,2,2,2,2,2,2,9,0,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,0,9,0,0,8,0,0,0,8,0,0,0,8,0,0,0,0,0}
		cannonAngle=90
		mirrorsTypeA=5
		mirrorsTypeB=2
	end

	-- Level by SUNNY
	if i == 23 then
		loadedMap={0,0,0,0,0,0,0,0,0,8,4,6,1,0,0,0,0,0,0,0,0,0,0,0,0,6,3,8,1,0,0,0,0,0,2,2,0,0,0,0,2,2,2,2,2,2,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,2,0,0,0,0,5,0,2,2,0,0,0,0,0,0,0,2,7,7,0,5,0,0,0,2,2,0,0,0,0,0,0,2,0,0,5,0,0,1,0,2,2,9,0,0,2,2,2,2,0,0,0,5,0,0,2,2,0,0,0,0,0,0,0,2,0,0,0,0,5,2,2,0,1,0,0,0,1,0,0,2,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,2,7,7,0,0,2,2,0,0,0,0,0,0,0,0,0,2,0,0,0,0,2,2,2,2,2,0,2,2,2,2,2,2,0,0,0,0,0,11,10,0,0,0,6,0,0,0,0,0,0,0}
		cannonAngle=0
		mirrorsTypeA=8
		mirrorsTypeB=2
	end

	-- Level by SUNNY 
	if i == 24 then
		loadedMap={0,0,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,3,3,3,3,3,3,3,3,3,11,3,0,0,0,0,0,3,0,0,0,0,0,0,0,3,10,3,0,0,0,0,0,3,0,3,3,3,3,3,0,3,0,3,0,0,0,0,0,3,0,3,0,1,0,3,0,3,0,3,0,0,0,0,0,3,0,8,8,0,4,0,1,3,1,3,0,0,0,0,0,3,0,3,3,3,3,3,0,3,0,3,0,0,0,0,0,3,0,3,0,0,0,0,0,3,0,3,0,0,0,0,0,3,0,3,3,3,3,3,3,3,0,3,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=270
		mirrorsTypeA=4
		mirrorsTypeB=0
	end


	-- Level by SUNNY
	if i == 25 then
		loadedMap={0,0,0,1,0,2,0,0,0,3,2,2,2,2,2,0,0,0,0,1,0,2,0,2,2,2,2,0,0,0,2,0,9,7,2,2,2,2,0,0,0,1,0,0,2,0,2,2,0,0,0,0,1,0,0,2,2,2,2,2,5,0,0,2,2,0,2,2,2,2,2,2,0,0,0,2,2,2,0,2,2,0,1,0,2,0,0,1,0,2,0,2,0,1,0,2,2,0,1,0,2,0,2,2,2,2,0,2,0,2,2,2,2,0,2,2,2,0,2,0,0,3,0,0,0,4,0,0,0,0,2,0,0,0,2,0,2,2,2,2,2,2,2,0,0,2,2,1,2,2,2,1,2,5,2,0,0,0,2,0,0,2,2,0,0,0,0,0,2,2,2,0,0,0,2,0,0,2,2,2,2,2,2,2,2,0,0,0,1,10,2,0,0,0,0,8,0,0,0,8,0,0,0,0,0,11,2,1}
		cannonAngle=90
		mirrorsTypeA=31
		mirrorsTypeB=4
	end

	-- Level by SUNNY.
	if i == 26 then
		loadedMap={0,5,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,2,2,2,2,2,2,1,2,5,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,2,2,2,2,2,0,2,2,2,2,2,2,1,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,2,0,0,0,0,0,0,1,0,0,0,0,0,0,2,11,2,0,0,0,0,0,0,0}
		cannonAngle=90
		mirrorsTypeA=7
		mirrorsTypeB=0
	end

	-- Level by SUNNY 
	if i == 27 then
		loadedMap={0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,2,0,2,0,2,0,2,0,2,0,2,5,2,0,2,0,0,2,0,2,0,2,11,2,0,2,0,2,0,2,1,2,2,0,2,0,2,10,2,0,2,0,2,1,2,0,2,0,0,2,5,2,0,2,1,2,1,2,0,2,0,2,0,2,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,2,0,2,0,2,5,2,0,2,5,2,0,2,0,2,0,0,2,5,2,5,2,0,2,0,2,0,2,0,2,0,2,2,0,2,0,2,0,2,0,2,0,2,0,2,1,2,0,0,2,0,2,0,2,0,2,1,2,0,2,0,2,0,2,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,0,2,0,2,5,2,0,2,5,2,0,2,0,2,0,2}
		cannonAngle=225
		mirrorsTypeA=8
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 28 then
		loadedMap={2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,2,2,0,2,2,2,2,0,2,7,2,2,0,0,2,1,0,2,0,2,0,0,3,0,2,1,1,2,0,0,2,0,3,2,0,2,0,0,0,0,2,4,1,6,0,0,2,2,2,2,0,2,2,2,2,0,2,2,2,2,0,0,2,0,0,0,0,3,0,0,2,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,2,0,0,0,0,2,2,2,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,2,2,2,0,0,5,0,5,0,0,0,0,10,11,0,0,2,5,2,0,5,0}
		cannonAngle=180
		mirrorsTypeA=7
		mirrorsTypeB=3
	end

	-- Level by SUNNY
	if i == 29 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,2,2,0,0,2,2,0,0,0,0,0,2,5,5,2,2,5,5,2,2,5,5,2,0,0,0,0,0,2,2,0,0,2,2,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,1,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,4,2,0,2,0,10,11,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,1,1,1,0,0,2,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,2,0,0,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,2}
		cannonAngle=180
		mirrorsTypeA=5
		mirrorsTypeB=3
	end

	-- Level by SUNNY
	if i == 30 then
		loadedMap={2,2,0,0,0,0,0,0,2,3,0,0,0,0,0,0,2,2,0,2,2,0,2,9,2,2,2,2,2,2,2,0,0,8,0,2,2,0,2,0,0,0,2,2,2,2,2,0,0,2,0,3,2,0,2,2,2,0,2,0,0,0,2,0,0,2,0,0,2,0,2,0,0,0,0,0,2,0,2,0,0,2,2,2,2,0,2,0,2,2,2,2,2,0,2,0,0,2,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,2,2,0,2,0,2,2,2,2,2,0,2,2,2,0,0,2,2,0,2,0,0,0,0,0,2,0,0,0,2,0,0,2,2,0,2,2,2,2,2,0,0,0,2,10,2,0,0,0,0,0,2,2,2,2,2,2,2,2,2,11,2,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4}
		cannonAngle=90
		mirrorsTypeA=11
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 31 then
		loadedMap={11,2,2,0,1,0,0,0,8,0,0,0,0,0,0,0,10,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,8,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,2,2,2,7,0,2,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,2,0,0,1,0,0,0,2,0,1,0,0,0,2,1,0,2,0,0,2,2,2,2,2,2,2,0,0,0,2,0,0,2,0,0,1,0,0,0,2,0,1,0,0,0,2,7,0,2,0,0,0,0,0,0,2,0,0,0,0,0,2,0,0,2,2,0,0,0,0,0,2,0,0,0,2,2,2,0,0,2,0,1,6,0,0,0,2,0,0,0,1,0,2,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,6,0,0,0,6,0,0,0,0,0,0,6,0,0}
		cannonAngle=270
		mirrorsTypeA=5
		mirrorsTypeB=6
	end

	-- Level by SUNNY
	if i == 32 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,2,2,0,0,0,0,0,0,0,2,0,0,0,11,0,2,0,0,2,0,0,0,0,0,0,2,0,0,0,10,0,2,1,0,2,0,0,0,0,2,0,2,0,2,0,0,0,2,0,0,2,0,0,0,2,0,2,2,2,0,0,0,0,0,2,2,0,0,0,2,0,0,0,2,0,2,0,9,0,0,0,0,0,0,2,0,0,0,0,0,8,0,8,1,6,0,0,0,0,0,0,0,0,0,0,0,0,2,0,9,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=270
		mirrorsTypeA=3
		mirrorsTypeB=3
	end

	-- Level by SUNNY
	if i == 33 then
		loadedMap={0,0,0,0,0,0,2,0,0,2,0,2,0,0,0,0,0,0,0,0,0,2,0,0,2,0,2,0,0,0,0,0,0,0,0,0,2,0,0,2,0,2,0,0,0,0,0,0,0,0,0,2,0,0,2,1,2,0,0,0,0,0,0,0,0,0,2,0,0,2,0,2,0,0,0,0,0,0,0,0,2,2,2,2,2,0,2,0,0,0,0,0,0,0,0,0,2,1,11,10,0,5,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,2,1,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,1,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0}
		cannonAngle=0
		mirrorsTypeA=4
		mirrorsTypeB=3
	end

	-- Level by SUNNY
	if i == 34 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,5,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=225
		mirrorsTypeA=5
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 35 then
		loadedMap={3,0,1,0,0,0,8,0,2,0,0,2,3,2,0,0,2,2,2,2,0,2,2,7,2,0,0,2,0,2,0,0,0,0,0,0,2,0,2,0,2,0,0,2,0,2,0,0,2,3,2,0,0,2,0,7,2,0,0,2,0,2,0,0,2,0,0,2,0,0,2,0,2,0,0,2,0,2,0,0,2,0,0,0,2,2,2,7,2,0,0,2,1,2,0,0,2,0,0,0,0,0,8,4,6,1,0,2,0,2,0,0,2,2,2,0,2,2,2,9,2,0,0,2,0,2,0,0,2,2,0,2,0,0,0,0,2,2,0,2,0,2,0,0,2,0,2,0,0,0,0,2,1,2,0,2,0,2,0,0,2,3,2,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,3,0,0}
		cannonAngle=90
		mirrorsTypeA=0
		mirrorsTypeB=6
	end

	-- Level by SUNNY
	if i == 36 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,2,5,2,0,0,0,0,0,0,0,0,0,0,0,4,11,6,1,6,0,0,0,0,0,0,0,0,0,0,0,0,5,2,5,2,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=90
		mirrorsTypeA=4
		mirrorsTypeB=4
	end

	-- Level by SUNNY
	if i == 37 then
		loadedMap={3,2,0,2,0,5,0,0,0,0,0,0,0,0,0,0,0,2,1,2,5,0,5,0,0,0,0,0,5,0,0,0,0,2,0,2,0,5,0,5,0,0,0,5,0,5,0,0,0,2,0,2,0,0,5,1,5,0,0,0,5,0,0,0,0,2,0,2,0,0,0,5,0,0,5,0,0,0,0,5,0,2,0,2,2,0,0,0,0,5,0,5,0,0,5,3,0,2,4,6,0,2,0,0,0,0,5,0,0,0,0,5,0,2,0,1,2,2,2,2,2,2,2,2,2,2,2,2,0,2,0,2,0,2,0,0,0,0,0,0,1,0,0,3,0,2,0,0,0,2,0,1,2,2,2,2,2,2,2,2,0,2,0,2,0,2,0,0,0,0,0,0,0,0,0,0,10,2,0,2,0,0,2,2,2,2,2,2,2,2,0,0,11,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=90
		mirrorsTypeA=4
		mirrorsTypeB=3
	end

	-- Level by SUNNY
	if i == 38 then
		loadedMap={11,0,9,0,7,0,6,0,9,0,8,0,7,0,8,0,10,6,0,8,0,6,0,7,0,6,0,9,0,8,0,7,9,0,7,0,7,0,9,0,9,0,9,0,7,0,6,0,0,8,0,6,0,8,0,8,0,6,0,6,0,6,0,6,9,0,7,0,7,0,9,0,6,0,7,0,9,0,9,0,0,8,0,7,0,6,0,6,0,6,0,7,0,9,0,6,9,0,7,0,7,0,9,0,9,0,7,0,7,0,9,0,0,6,0,8,0,8,0,9,0,7,0,8,0,8,0,6,9,0,9,0,6,0,6,0,9,0,9,0,7,0,7,0,0,8,0,8,0,9,0,6,0,8,0,8,0,6,0,6,9,0,9,0,7,0,7,0,9,0,7,0,9,0,7,0,0,6,0,7,0,6,0,8,0,6,0,6,0,9,0,9,7,0,7,0,6,0,8,0,9,0,7,0,0,0,6,1}
		cannonAngle=270
		mirrorsTypeA=17
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 39 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,2,3,2,3,2,3,2,3,2,3,2,4,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,2,2,0,2,0,2,1,2,1,2,0,2,0,2,0,2,10,6,0,0,0,0,0,0,0,0,5,0,0,0,0,0}
		cannonAngle=0
		mirrorsTypeA=2
		mirrorsTypeB=2
	end

	-- Level by SUNNY
	if i == 40 then
		loadedMap={0,0,0,0,0,0,0,2,10,2,0,0,0,0,0,0,0,0,2,2,0,0,0,2,0,2,0,0,2,2,0,0,0,2,0,0,2,0,0,2,0,2,0,2,0,0,2,0,0,0,0,0,2,0,0,2,0,2,0,0,1,0,2,0,0,0,0,2,0,0,0,2,0,2,0,0,0,2,0,0,0,0,2,0,0,0,0,2,0,2,0,0,2,0,0,0,0,0,2,0,0,0,0,2,0,2,1,0,2,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,1,0,0,0,0,0,3,0,0,0,0,2,0,2,0,1,4,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0}
		cannonAngle=270
		mirrorsTypeA=4
		mirrorsTypeB=3
	end

	-- Level by SUNNY
	if i == 41 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,10,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=45
		mirrorsTypeA=4
		mirrorsTypeB=0
	end

	-- Level by SUNNY
	if i == 42 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,0,4,0,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,2,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,2,0,0,0,2,0,2,2,2,2,2,2,2,0,0,0,2,0,0,0,2,5,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,5,2,0,0,0,0,0,0,0,0,0,2,0,0,0,2,5,2,0,0,0,0,0,0,0,0,0,2,0,0,0,2,5,2,0,0,3,0,0,0}
		cannonAngle=180
		mirrorsTypeA=2
		mirrorsTypeB=2
	end

	-- Level by SUNNY
	if i == 43 then
		loadedMap={0,0,0,0,0,0,0,0,2,5,1,5,0,0,0,0,0,0,0,0,0,0,0,11,2,0,4,1,0,0,0,0,0,0,0,0,0,0,0,10,2,5,1,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=270
		mirrorsTypeA=7
		mirrorsTypeB=2
	end

	-- Level by SUNNY
	if i == 44 then
		loadedMap={0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,2,1,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0,2,0,0,0,0,0,0,0,1,0,0,2,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,2,0,0}
		cannonAngle=225
		mirrorsTypeA=3
		mirrorsTypeB=1
	end

	-- Level by SUNNY
	if i == 45 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,2,2,4,2,2,2,0,0,0,0,0,0,0,0,0,0,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=270
		mirrorsTypeA=2
		mirrorsTypeB=1
	end

	-- Level by SUNNY
	if i == 46 then
		loadedMap={0,0,1,0,0,0,4,6,0,0,5,0,0,0,0,0,0,2,2,2,0,2,2,2,0,0,2,1,0,2,0,2,0,0,2,0,0,2,0,0,0,2,0,2,0,2,2,2,0,0,2,0,0,2,2,2,0,2,2,2,1,2,2,2,0,0,2,0,0,2,0,0,0,2,0,2,0,2,0,2,0,0,2,0,0,2,2,2,0,2,0,2,9,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,10,2,3,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,2,0,0,2,0,2,0,2,0,0,2,0,2,0,2,0,0,2,0,2,0,2,0,2,2,0,2,2,0,2,2,0,0,2,0,2,0,2,0,2,0,2,2,0,2,0,2,2,2,0,0,0,2,0,0,2,0,2,2,0,2,0,2}
		cannonAngle=180
		mirrorsTypeA=4
		mirrorsTypeB=2
	end

	-- Level by SUNNY
	if i == 47 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,1,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,4,1,0,0,0,2,0,0,0,0,0,0,0,2,0,0,10,3,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,3,0,0,0,0,0,0,0,2,2,2,2,2,2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=90
		mirrorsTypeA=3
		mirrorsTypeB=5
	end

	-- Level by SUNNY
	if i == 48 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,2,2,1,0,2,1,0,5,0,0,0,0,0,0,0,0,2,4,0,6,5,0,0,5,0,0,0,0,0,0,0,0,2,1,2,0,2,1,1,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,2,0,0,0,0,0,2,0,0,0,0,3,0,0,0,10,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		cannonAngle=0
		mirrorsTypeA=5
		mirrorsTypeB=1
	end

	-- Bonuslevel 1 of Laserix 2
	if i == 49 then
		loadedMap={5,5,5,5,5,5,5,6,0,0,0,0,0,0,0,0,5,5,0,0,0,0,0,6,0,0,0,0,0,0,0,0,5,5,0,0,0,0,0,6,0,0,0,3,0,0,0,0,5,5,0,0,0,0,0,6,0,5,0,0,0,5,0,0,5,5,0,0,0,0,0,6,5,1,5,0,5,1,5,0,5,5,0,0,0,0,0,6,0,5,0,0,0,5,0,0,5,5,0,0,0,0,0,0,0,0,0,1,0,0,0,0,5,5,0,0,0,0,0,6,11,11,0,11,0,11,11,11,5,5,0,0,0,0,0,6,11,11,0,11,0,11,0,11,5,5,0,0,0,0,0,6,11,11,0,11,0,11,0,11,5,5,1,0,2,0,0,6,11,0,11,11,0,11,0,11,5,0,0,1,0,0,0,6,11,0,11,11,0,11,0,11,5,10,4,5,5,5,5,5,11,0,0,11,0,11,11,11}
		cannonAngle=45
		mirrorsTypeA=2
		mirrorsTypeB=3
	end

	-- Bonuslevel 2 of Laserix 2
	if i == 50 then
		loadedMap={0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,11,0,0,0,11,11,11,11,0,11,0,1,10,0,0,0,11,0,0,0,11,0,0,11,2,11,0,1,0,0,2,0,11,1,0,0,11,0,0,11,0,11,0,0,4,0,0,0,11,0,0,0,11,0,0,11,0,11,0,0,0,0,0,1,11,0,0,0,11,0,0,11,1,11,2,0,0,1,0,0,11,11,11,0,11,11,11,11,0,11,11,11,0,0,3,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,5,0}
		cannonAngle=225
		mirrorsTypeA=5
		mirrorsTypeB=4
	end

	-- Bonuslevel 1 of Laserix 3 by SUNNY
	if i == 51 then
	    loadedMap={0,0,0,1,0,0,0,0,2,0,0,0,0,0,5,3,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,5,4,5,0,0,0,2,0,0,2,1,0,0,0,0,0,1,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,1,0,0,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,1,0,3,0,0,0,0,0,9,5,0,0,0,0,0,0,0,0,6,0,0,0,0,0,1,3,2,2,2,2,2,2,0,0,2,0,0,0,0,0,2,0,0,0,3,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,10,0}
        cannonAngle=90
		mirrorsTypeA=4
		mirrorsTypeB=4
	end

	-- Bonuslevel 2 of Laserix 3 by SUNNY
	if i == 52 then
		loadedMap={10,0,0,0,0,0,0,0,0,0,0,5,0,5,0,0,0,0,0,1,0,5,0,0,0,1,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,5,0,0,5,0,1,0,0,0,1,0,0,0,5,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,5,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,1,0,0,2,0,1,0,0,5,0,5,2,2,1,2,2,0,0,2,0,0,0,0,0,0,0,2,2,0,5,0,2,0,2,0,0,0,0,0,1,0,0,2,2,5,0,5,2,2,0,0,0,0,0,0,0,0,2,0,2,2,2,2,2,0,2,0,0,0,5,0,0,2,0,2,0,2,0,2,1,0,0,2,0,0,0,0,2,0,2,0,2,0,2,0,2,0,0,0,2}
		cannonAngle=315
		mirrorsTypeA=20
		mirrorsTypeB=0
	end

	-- fin des levels

	fixArray()

end

function save()
	fi = pge.file.open("click1.wav", PGE_FILE_WRONLY+PGE_FILE_TRUNC+PGE_FILE_CREATE)
	if fi then
		pge.file.write(fi,level..[[ ]])
		pge.file.close(fi)
	end
end

function load()
	fi = pge.file.open("click1.wav", PGE_FILE_RDONLY)
	if fi then
		loadedLevel = pge.file.read(fi,2)+0
		pge.file.close(fi)
	end
	if loadedLevel == nil then loadedLevel = 1 end
end


function newLevel()


	if level>loadedLevel then
		save()
		loadedLevel=level
	end


	levelCleared=false
	for j=0, 12, 1 do
		for i=0, 15, 1 do
			diamondsArray[j][i]=0
		end

	end

	-- affichage des messages

	loadMap(level)
	if level==4 then
		showMsg(5)
	end

	loadMap(level)
	if level==7 then
		showMsg(4)
	end

	loadMap(level)
	if level==1 then
		showMsg(2)
	end

	laserColor1 = pge.gfx.createcolor(255, 255, 255)
	if level>=1 and level<=5 then
		laserColor2 = pge.gfx.createcolor(0, 24, 255)
	end

	if level>=6 and level<=10 then
		laserColor2 = pge.gfx.createcolor(255, 198, 0)
	end

	if level>=11 and level<=14 then
		laserColor2 = pge.gfx.createcolor(32, 168, 0)
	end

	if level==15 then
		laserColor2 = pge.gfx.createcolor(238, 69, 142)
	end

	if cannonAngle==0 then
		xpos=laserStartX+1
		ypos=laserStartY
	end

	if cannonAngle==45 then
		xpos=laserStartX+1
		ypos=laserStartY-1
	end

	if cannonAngle==90 then
		xpos=laserStartX
		if level==11 then
			ypos=laserStartY-2
		else
			ypos=laserStartY-1
		end
	end

	if cannonAngle==135 then
		xpos=laserStartX-1
		ypos=laserStartY-1
	end

	if cannonAngle==180 then
		xpos=laserStartX-1
		ypos=laserStartY
	end

	if cannonAngle==225 then
		xpos=laserStartX-1
		ypos=laserStartY+1
	end

	if cannonAngle==270 then
		xpos=laserStartX
		ypos=laserStartY+1
	end

	if cannonAngle==315 then
		xpos=laserStartX+1
		ypos=laserStartY+1
	end

	resetLaser()
	updateStaticImage()
end


function fixArray()


	local k=0
	map={}
	for j=0, 12, 1 do
		map[j]={}
		for i=0, 15, 1 do
			map[j][i]=loadedMap[k+1]
			if map[j][i]==10 then
				map[j][i]=13
				laserStartX=i
				laserStartY=j
			else
				if map[j][i]>=11 then
					map[j][i]=map[j][i]-1
				else
					if map[j][i]==0 then
						map[j][i]=14
					end
					if map[j][i]==4 then
						warpX=i
						warpY=j
					end

					if map[j][i]==1 then
						diamondsArray[j][i]=1
						diamondsLoaded=diamondsLoaded+1
					end
				end
			end
			map[j][i]=map[j][i]*-1
			k=k+1
		end

	end

end


function drawMsg()
	if msg_to_draw then
		screen_blit(130, 50, msg_to_draw, 0, 0, 220, 100, true)
	end
end


function showMsg(n)


	if n == 0 then
		msg_to_draw = nil
	end

	if n == 1 then
		msg_to_draw = msg_1
	end

	if n == 2 then
		msg_to_draw = msg_2
	end

	if n == 5 then
		msg_to_draw = msg_5
	end

	if n == 4 then
		msg_to_draw = msg_4
	end

	message=n
end


function shoot()
	laserAngle=cannonAngle
	laserX=laserStartX
	laserY=laserStartY
	if stopLaser == false then shootLoops=shootLoops+1 end
	if shootLoops > 150 then shootLoops = 150 end
	stopLaser = false
	for kk = 1,shootLoops,1 do

		if stopLaser~= true then               --and map[xtmp][]
			if map[laserY][laserX]>=0 then
				if kk == shootLoops then pge.wav.play(sound_hit_mirror) end
				laserAngle=(map[laserY][laserX]*2)-laserAngle
				if laserAngle>=360 then
					laserAngle=laserAngle-360
				end
				if laserAngle<0 then
					laserAngle=laserAngle+360
				end

			end
			laserYOld=laserY
			laserXOld=laserX


			if laserAngle==0 then
				laserX=laserX+1
			end
			if laserAngle==45 then
				laserX=laserX+1
				laserY=laserY-1
			end
			if laserAngle==90 then
				laserY=laserY-1
			end
			if laserAngle==135 then
				laserX=laserX-1
				laserY=laserY-1
			end
			if laserAngle==180 then
				laserX=laserX-1
			end
			if laserAngle==225 then
				laserX=laserX-1
				laserY=laserY+1
			end
			if laserAngle==270 then
				laserY=laserY+1
			end
			if laserAngle==315 then
				laserX=laserX+1
				laserY=laserY+1
			end


			if laserX <0 or laserX > 15 or laserY < 0 or laserY > 12 then
				stopLaser=true
				laserX=laserXOld  --important!
				laserY=laserYOld
			end


			if  map[laserY][laserX]==-11 or map[laserY][laserX]==-2 then
				stopLaser=true
			end

			if  laserAngle~=270 and map[laserY][laserX]==-9 then
				stopLaser=true
			end

			if  laserAngle~=180 and map[laserY][laserX]==-8 then
				stopLaser=true
			end

			if  laserAngle~=90 and map[laserY][laserX]==-7 then
				stopLaser=true
			end

			if  laserAngle~=0 and map[laserY][laserX]==-6 then
				stopLaser=true
			end


			if  map[laserY][laserX]==-5 then
				hitFlash=true
				flashX=laserX
				flashY=laserY
				keyDelay=100  --show animation, reset laser and set keyDelay to 0
				if kk == shootLoops then pge.wav.play(sound_elec) end
			end

			-- this "moveblock" feature sounds cool, where is the level for it?
			if diamondsArray[laserY][laserX]==1 then  --diamond
				diamondsArray[laserY][laserX]=2
				diamonds=diamonds+1        --then check if level is cleared
				if kk == shootLoops then pge.wav.play(sound_diamond) end

				checkMoveBlock()     -- up & down block  Could be VERY slow.. optimize func if anything


				if diamonds==diamondsLoaded then
					levelCleared=true
				end
			end


		end		--end if


		if stopLaser==true then --Very important
			laserX=laserXOld
			laserY=laserYOld
		end

		drawLaser()

		if map[laserY][laserX]==-3 then  --warp
			laserX=warpX
			laserY=warpY
			laserYOld=laserY
			laserXOld=laserX
		end

		if stopLaser == true then break end
	end --for

end

function drawLaser()

	local xtmp=drawStartX+laserXOld*21+10
	local xtmp2=drawStartX+laserX*21+10
	local ytmp=laserYOld*21+10
	local ytmp2=laserY*21+10


	if laserAngle==0 then
		if stopLaser==true then
			xtmp2=xtmp2+11
		end
	end

	if laserAngle==180 then
		if stopLaser==true then
			xtmp2=xtmp2-10
		end
	end

	if laserAngle ==90 then
		if stopLaser==true then
			ytmp2=ytmp2-10
		end
	end

	if laserAngle ==270 then
		if stopLaser==true then
			ytmp2=ytmp2+11
		end
	end
	
	-- -------------

	if laserAngle ==315 then
		if stopLaser==true then
			xtmp2=xtmp2+11  --11
			ytmp2=ytmp2+11  --11
		end
	end

	if laserAngle ==225 then
		if stopLaser==true then
			xtmp2=xtmp2-10
			ytmp2=ytmp2+11
		end
	end

	if laserAngle ==135 then
		if stopLaser==true then
			xtmp2=xtmp2-10
			ytmp2=ytmp2-10
		end
	end

	if laserAngle ==45 then
		if stopLaser==true then
			xtmp2=xtmp2+11
			ytmp2=ytmp2-10
		end
	end


	pge.gfx.drawline(xtmp, ytmp, xtmp2, ytmp2, laserColor1)	--middle. Always drawn

	if laserAngle == 0 or laserAngle == 180 then --outer
		pge.gfx.drawline(xtmp, ytmp+1, xtmp2, ytmp2+1, laserColor2)
		pge.gfx.drawline(xtmp, ytmp-1, xtmp2, ytmp2-1, laserColor2)
	else
		pge.gfx.drawline(xtmp+1, ytmp, xtmp2+1, ytmp2, laserColor2)
		pge.gfx.drawline(xtmp-1, ytmp, xtmp2-1, ytmp2, laserColor2)
	end


end


function checkMoveBlock()
	--[[ todo - can't figure out what this is for, leaving it out for now -retrobits
	     it wouldn't work to call draw() at this point anyhow due the changes I've
	     made for pge.
	     
	for j=0, 12, 1 do
		for i=0, 15, 1 do
			if map[j][i]==-11 then
				map[j][i]=-12
				moveBlockChanges=moveBlockChanges+1
				draw()
			else
				if map[j][i]==-12 then
					map[j][i]=-11
					moveBlockChanges=moveBlockChanges+1
					draw()
				end
			end
		end
	end
	]]
end


function resetLaser()
	-- if laserOn then
	for j=0, 12, 1 do
		for i=0, 15, 1 do
			if (diamondsArray[j][i]==2) then
				diamondsArray[j][i]=1
			end
		end
	end
	if diamonds > 0 then
		for i=0, moveBlockChanges, 1 do
			checkMoveBlock()
		end
	end
	moveBlockChanges=0
	drawStartX=72
	staticX=0
	diamonds=0
	hitFlash=false
	fx_lighting_frame=0
	stopLaser=false
	levelCleared=false
	laserOn=false
	laserX=laserStartX
	laserY=laserStartY
	laserYOld=laserY
	laserXOld=laserX
	shootLoops=0
	laserAngle=cannonAngle
	--end

end


function update()
	x0 = 0
	y0 = 0
	tmp = map[ypos][xpos]

	press_start 		= pge.controls.pressed(PGE_CTRL_START)
	press_select 		= pge.controls.pressed(PGE_CTRL_SELECT)
	press_cross 		= pge.controls.pressed(PGE_CTRL_CROSS)
	press_circle 		= pge.controls.pressed(PGE_CTRL_CIRCLE)
	held_square 	   	= pge.controls.held(PGE_CTRL_SQUARE)
	press_triangle  	= pge.controls.pressed(PGE_CTRL_TRIANGLE)
	press_rtrigger 		= pge.controls.pressed(PGE_CTRL_RTRIGGER)
	press_ltrigger 		= pge.controls.pressed(PGE_CTRL_LTRIGGER)
	held_right    		= pge.controls.held(PGE_CTRL_RIGHT)
	held_left    		= pge.controls.held(PGE_CTRL_LEFT)
	held_up      		= pge.controls.held(PGE_CTRL_UP)
	held_down     		= pge.controls.held(PGE_CTRL_DOWN)
	press_analog_right	= pge.controls.analogx() > 100
	press_analog_left	= pge.controls.analogx() < -100
	press_analog_up		= pge.controls.analogy() > 100
	press_analog_down	= pge.controls.analogy() < -100

	if hintTime>0 then
		hintTime=hintTime-1
	end

   --MESSAGES AND MENUS --MUST be before the other keys
	if press_cross then
		if  message==1 then
			press_cross = nil
			hintTime=60
			showMsg(0)
			keyDelay=7
		end
		if  message==2 then
			press_cross = nil
			showMsg(0)
			keyDelay=7
		end
		if  message==5 then
			press_cross = nil
			showMsg(0)
			keyDelay=7
		end
		if  message==4 then
			press_cross = nil
			showMsg(0)
			keyDelay=7
		end

		if menu==2 then --must be over menu 1
			press_cross = nil
			if tmpLevel<= loadedLevel then
				level=tmpLevel
				keyDelay=5
				menu=0
				mp3_vol = 15000
				set_mp3_volume()
				newLevel()
			end                          --else play error sound
		end

		if menu==1 then
			press_cross = nil
			menu=2
			showMenu()
			keyDelay=10
		end

		if menu==3 then
			press_cross = nil
			menu=1
			showMenu()
			keyDelay=10
		end

		if  message==3 then
			press_cross = nil
			level=1
			newLevel()
			showMsg(0)
			--menu=1
			--showMenu()
		end


	end


	if menu==2 then
		if held_right and tmpLevel<maxLevel and keyDelay==0 then
			pge.wav.play(sound_menu_click)
			tmpLevel=tmpLevel+1
			gotoMenuX=gotoMenuX-140
			keyDelay=7
		end

		if held_left and tmpLevel>1 and keyDelay==0 then
			pge.wav.play(sound_menu_click)
			tmpLevel=tmpLevel-1
			gotoMenuX=gotoMenuX+140
			keyDelay=7
		end
	end

	if press_circle then 
		if message==1 then
			press_circle = nil
			showMsg(0)
			keyDelay=7
		end
	end


	--MESSAGES END


	if message==0 then


		if keyDelay==0 then
		
			if (held_right) then  --make aim red if out of array
				rightPress=true
				xpos=xpos+1
				keyDelay=10-acc
				acc=3
			else
				if rightPress==true then       --release
					rightPress=false
					acc=0
				end
			end

			if (held_left) then  --make aim red if out of array
				leftPress=true
				xpos=xpos-1
				keyDelay=10-acc
				acc=3
			else
				if leftPress==true then       --release
					leftPress=false
					acc=0
				end
			end

			if (held_up) then  --make aim red if out of array
				upPress=true
				ypos=ypos-1
				keyDelay=10-acc
				acc=3
			else
				if upPress==true then       --release
					upPress=false
					acc=0
				end
			end

			if (held_down) then  --make aim red if out of array
				downPress=true
				ypos=ypos+1
				keyDelay=10-acc
				acc=3
			else
				if downPress==true then       --release
					downPress=false
					acc=0
				end
			end
			
			if ypos > 12 then ypos = 0 end
			if ypos < 0 then ypos = 12 end
			if xpos > 15 then xpos = 0 end
			if xpos < 0 then xpos = 15 end
		end
		

		if press_cross and mirrorsTypeA>0 then 
			if  tmp==-14 or tmp==-10 then
				mirrorsTypeA=mirrorsTypeA-1
				map[ypos][xpos]=90
				keyDelay=4
				pge.wav.play(sound_place_mirror)
				resetLaser()
			end
		end

		if press_circle and mirrorsTypeB>0 then
			if  tmp==-14 or tmp==-10 then
				mirrorsTypeB=mirrorsTypeB-1
				map[ypos][xpos]=22.5
				keyDelay=4
				pge.wav.play(sound_place_mirror)
				resetLaser()
			end
		end


		if press_ltrigger and tmp >=0 then  --activ xpos/ypos
			tmp=tmp+45
			if tmp>= 360 then
				tmp = tmp -360
			end
			map[ypos][xpos]=tmp
			keyDelay=12
			resetLaser()
		end


		if press_rtrigger and tmp >=0 then  --activ xpos/ypos
			tmp=tmp-45
			if tmp < 0 then
				tmp = tmp +360
			end
			map[ypos][xpos]=tmp
			keyDelay=12
			resetLaser()
		end


		if press_select and menu== 0 then 
			press_select = nil
			showMsg(1)
		end

		if press_start and menu == 0 then 
			press_start = nil
			if level>loadedLevel then
				save()
			end
			menu=2
		end

		if press_start and menu == 2 then 
			press_start = nil
			menu=1
		end


		if held_square then
			if mirrorSelected==false then
				if tmp>=0 then
					mirrorSelected=true
					xposActiv=xpos
					yposActiv=ypos
				end
			else
				if tmp==-14 or tmp==-10 then
					map[ypos][xpos]=map[yposActiv][xposActiv]
					map[yposActiv][xposActiv]=-14
					xposActiv=xpos
					yposActiv=ypos
					resetLaser()
					pge.wav.play(sound_move_mirror)
				end
			end
		else
			mirrorSelected=false
		end


		if press_triangle then        
			trianglePress=true
		else
			if trianglePress==true then
				trianglePress=false
				if laserOn==true then
					resetLaser()
				else
					laserOn=true
				end
			end
		end

	end

	-- Music On/Off -------------------------------------------

	if  press_analog_right then pge.mp3.stop()
	end
	if  press_analog_left then pge.mp3.play("song1.mp3") pge.mp3.loop(true)
		mp3_fac = 2
	end
	if  press_analog_up then pge.mp3.play("song2.mp3") pge.mp3.loop(true)
		mp3_fac = 1
	end
	if  press_analog_down then ScreenShot()


	end
	if menu==1 then 
		mp3_vol = mp3_vol - 500
		if mp3_vol < 0 then mp3_vol = 0 end
		set_mp3_volume()
	else 
		mp3_vol = 30000
		set_mp3_volume()
	end

	if keyDelay>0 then
		keyDelay=keyDelay-1
	end

end


function drawAim()

	if map[ypos][xpos]==-14 or map[ypos][xpos]==-10 or map[ypos][xpos]>=0 then
		screen_blit(drawStartX+xpos*21, ypos*21, aim, 0 , 0, 21, 21, true)
		if mirrorSelected then
			screen_blit(drawStartX+xposActiv*21, yposActiv*21, aim, 42 , 0, 21, 21, true)
		end
	else
		screen_blit(drawStartX+xpos*21, ypos*21, aim, 21 , 0, 21, 21, true)
	end


end

function printFont(x,y,number)

	if number >= 10 then
		number=number/10
		local decimal=(number-pge.math.floor(number))*10
		number=pge.math.floor(number)
		screen_blit(x, y, font, 11*number, 0, 11, 11, true)
		screen_blit(x+14, y, font, 11*decimal, 0, 11, 11, true)
	else
		screen_blit(x, y, font, 11*number, 0, 11, 11, true)
	end

end

function blitChar(target, char, posx, posy)
	if target == nil then
		screen_blit(posx,posy, font1,char2font(char),0,LetterPixelsWide,LetterPixelsTall,true)
	else
		error("blitChar to texture is unsupported")
		--tex_blit(target,posx,posy, font1,char2font(char),0,LetterPixelsWide,LetterPixelsTall,true)
	end
end -- blitChar

function blitString(myTarget, possx, possy, thestring)
	incjab = 1
	for w = 1, string.len(thestring) do
		blitChar(myTarget, string.upper(string.sub(thestring, w,w)), possx + incjab, possy)
		incjab = incjab + LetterPixelsWide
	end -- end for
end -- blitString


function showMenu()
	if menu==3 then
		menu1 = 0
		screen_blit(0, 0, endscreen, 0, 0, 480, 272, true)
	end

	if menu==1 then
		if menu1 < 2 then
			screen_blit(0, 0, menu_background, 0, 0, 480, 272, true)
			menu1 = menu1 + 1
		end

	end


	if menu==2 then
		menu1 = 0
		screen_blit(0, 0, level_background, 0, 0, 480, 272, true)


		if menuX>gotoMenuX then
			menuX=menuX-20
		end

		if menuX<gotoMenuX then
			menuX=menuX+20
		end

		for i=1, maxLevel, 1 do
			screen_blit(menuX+(i-1)*140, 35, menu_lvl[i], 0, 0, 120, 80, true)
			if loadedLevel<i  and loadedLevel<maxLevel then
				screen_blit(menuX+40+(i-1)*140, 40, lock, 0, 0, 40, 65, true)

			end
		end

	end

	if menu==0 then
		menu1 = 0
	end
end


function updateStaticImage()

	tex_blit(staticImage,0, 0, gui, 0, 0, 480, 272, true)
	tex_blit(staticImage,drawStartX, 0, background, 0, 0, 336, 273, true)

	for j=0, 12, 1 do
		for i=0, 15, 1 do
			if map[j][i]~=-14 and map[j][i]~=-11 and map[j][i]~=-12 and map[j][i]~=-10 then
				if map[j][i]==-13 then
					tex_blit(staticImage,drawStartX+i*21, j*21, cannon, cannonAngle*21/45  , 0, 21, 21, true)
				else
					tex_blit(staticImage,drawStartX+i*21, j*21, objectImage, ((map[j][i]*-1)-1)*21 , 0, 21, 21, true)
				end
			end
		end
	end
end

function draw() --also center the image
	if menu==0 then
		if levelCleared==true then  --fulkod
			staticX=staticX-5
		end


		if staticX < -120 then
			if level<maxLevel then
				mp3_vol = 30000
				set_mp3_volume()
				level=level+1
				menu=2 --go to the level screen
				tmpLevel=tmpLevel+1 --simulate change level
				gotoMenuX=gotoMenuX-140
				newLevel()
			else
				if level>loadedLevel then
					save()
				end
				loadedLevel=maxLevel
				--tmpLevel=1
				level=1
				--gotoMenuX=menuX
				keyDelay=10
				newLevel()
				menu=3
				showMenu()
			end

		end

		screen_blit(0, 0, staticImage, 0 , 0, 480, 272, true)

		for j=0, 12, 1 do
			for i=0, 15, 1 do

				if map[j][i]>=0 and map[j][i] == pge.math.floor (map[j][i]) then    --DRAW MIRRORS TYPE A
					screen_blit(drawStartX+i*21, j*21, mirrorsA, (map[j][i]*21)/45 , 0, 21, 21, true)
				end
				if map[j][i]> 0 and map[j][i] ~= pge.math.floor (map[j][i]) then    --DRAW MIRRORS TYPE B
					screen_blit(drawStartX+i*21, j*21, mirrorsB, ((map[j][i]-22.5)*21)/45 , 0, 21, 21, true)
				end
				if map[j][i]== -11 then    --DRAW DOWN BLOCK -- why are none of these in the levels? -retrobits
					screen_blit(drawStartX+i*21, j*21, objectImage, ((map[j][i]*-1)-1)*21 , 0, 21, 21, true)
				end
				if map[j][i]== -12 then    --DRAW UP BLOCK --STATIC IMAGE FUNKAR D???  -- why are none of these in the levels? -retrobits
					screen_blit(drawStartX+i*21, j*21, objectImage, ((map[j][i]*-1)-1)*21 , 0, 21, 21, true)
				end
				if diamondsArray[j][i]==2 then
					screen_blit(drawStartX+i*21, j*21, fx, 0 , 0, 21, 21, true)
				end

				if hintTime>0 then
					if map[j][i]==-10 and math.mod(hintTime,4)==0   then
						screen_blit(drawStartX+i*21, j*21, objectImage, 189 , 0, 21, 21, true)
					end
				end


			end
		end


		drawAim()

		if laserOn then
			shoot()
		end

		if hitFlash then
			if fx_lighting_frame<16 then
				frame_width = 21
				if fx_lighting_frame == 15 then frame_width = 19 end -- texture is 2 px short -retrobits
				screen_blit(drawStartX+flashX*21, flashY*21, fx_lighting, fx_lighting_frame*21 , 0, frame_width, 21, true)
				fx_lighting_frame=fx_lighting_frame+1
				stopLaser=true
			else
				resetLaser()
				-- hitFlash=false
				keyDelay=0
				levelClearded=false
			end
		end

		drawMsg()

		--GUI
		if message~=3 then
			printFont(418, 12, diamondsLoaded-diamonds)
			printFont(418,62,mirrorsTypeA)
			printFont(418,94,mirrorsTypeB)
			printFont(20,30,level)
		end
		--GUI end

	else
		showMenu(menu)

	end --if menu==false


end


load()


diamondsArray={}      --must be before loadMap

for j=0, 12, 1 do
	diamondsArray[j]={}
	for i=0, 15, 1 do
		diamondsArray[j][i]=0
	end
end


pge.controls.update()
pge.gfx.startdrawing()
newLevel()

-- INIT END


-- GAME LOOP

while pge.running() do

	update()
	draw()

	pge.gfx.enddrawing()
	pge.gfx.swapbuffers(true)
	
	pge.controls.update()
	pge.gfx.startdrawing()

	if levelCleared==false then
		if press_select and menu==1 then
			pge.mp3.stop()
			break
		end
	end
end

-- GAME LOOP END

pge.exit()
